import sys
sys.setrecursionlimit(10 ** 9)


def towers(num, power):
    if power == 0:
        return
    c = nn[num]
    lst.add(num)
    for x in c:
        lst.add(x)
        towers(x, power - 1)


n, m, k = map(int, input().split())
nn = {i: set() for i in range(1, n + 1)}
for i in range(m):
    a, b = map(int, input().split())
    nn[a].add(b)
    nn[b].add(a)
lst = set()
for i in range(k):
    t, p = map(int, input().split())
    towers(t, p)
print(len(lst))
print(*sorted(lst))
